//+------------------------------------------------------------------+
//|                                              Rsi CelticHeart.mq4 |
//|                                                           .....h |
//|                                                 hayseedville.com |
//+------------------------------------------------------------------+ //http://www.forexfactory.com/showthread.php?t=202074
#property copyright ".....h"
#property link      "hayseedville.com"

#property indicator_chart_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Red



extern int fastrsi      =   42;
extern int slowrsi      =   84;
extern int length       =  500; 
extern int offset       =    2;
double FastRsi[];
double SlowRsi[];
double CrossUp[];
double CrossDown[];
     
       datetime CheckTime;
//---
int init()
 {
  string short_name;

  //---- 
  //SetIndexStyle (0, DRAW_LINE, STYLE_SOLID, 1);
  SetIndexBuffer(0, FastRsi);
  //SetIndexStyle (1, DRAW_LINE, STYLE_SOLID, 1);
  SetIndexBuffer(1, SlowRsi);
  
  SetIndexBuffer(2, CrossUp);
  SetIndexStyle(2, DRAW_ARROW, EMPTY,3,Lime);
  SetIndexArrow(2, 233);
   
  SetIndexBuffer(3, CrossDown);
  SetIndexStyle(3, DRAW_ARROW, EMPTY,3,Red);
  SetIndexArrow(3, 234);
   
  //---- 
  short_name="CELTIC RSI("+fastrsi+")  RSI("+slowrsi+")";
  IndicatorShortName(short_name);
  SetIndexLabel(0,short_name);
  short_name="CELTIC RSI("+slowrsi+")";
  SetIndexLabel(1,short_name);

  SetIndexDrawBegin(0,fastrsi);
  SetIndexDrawBegin(1,slowrsi);
}


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start() 
{
  int i,bars;

 	if(length==0) bars=Bars-1;
   else
      bars=length-1;


    for (i=bars; i>=0; i--)
    { 
    FastRsi[i]=iRSI(NULL, 0, fastrsi, PRICE_CLOSE, i);
    SlowRsi[i]=iRSI(NULL, 0, slowrsi, PRICE_CLOSE, i);
    
    if((FastRsi[i+1] >= SlowRsi[i+1]) && (FastRsi[i+2] < SlowRsi[i+2])) {CrossUp[i+1]   = High[i+1] + offset*Point;}//  
    if((FastRsi[i+1] <= SlowRsi[i+1]) && (FastRsi[i+2] > SlowRsi[i+2])) {CrossDown[i+1] = Low[i+1]  - offset*Point;}//  
    }
    
    double fastrsi1  =  iRSI(NULL, 0, fastrsi, PRICE_CLOSE, 1); 
    double fastrsi2  =  iRSI(NULL, 0, fastrsi, PRICE_CLOSE, 2); 
    double slowrsi1  =  iRSI(NULL, 0, slowrsi, PRICE_CLOSE, 1); 
    double slowrsi2  =  iRSI(NULL, 0, slowrsi, PRICE_CLOSE, 2); 
      
    if(CheckTime==iTime(NULL,0,0)) return(0); else CheckTime = iTime(NULL,0,0);
     { 
     if((fastrsi1 >= slowrsi1) && (fastrsi2 < slowrsi2)) {Alert( Symbol() + "   " + Period()+ " Minute  Rsi(" + fastrsi + ") crossed above Rsi(" + slowrsi +") ");}//PlaySound("alert.wav");} 
     if((fastrsi1 <= slowrsi1) && (fastrsi2 > slowrsi2)) {Alert( Symbol() + "   " + Period()+ " Minute  Rsi(" + fastrsi + ") crossed below Rsi(" + slowrsi +") ");}//PlaySound("alert.wav");} 
     }
     
     
     return(0);
    }

//+------------------------------------------------------------------+.....h



